<template>
  <div :key="$route.path">
      <SfLoader v-if="loading" :loading="loading" class="sw-gs-page-loader"/>

      <SwGsError v-else-if="error && !(notAuthorizedError || notYetAccessibleError)" :error="error"></SwGsError>

      <SwGsLoginPage v-else-if="!isClientAuthenticated && !joinedAppointment && !notYetAccessibleError"
                     :isGuide="false"/>

      <SwGsWaitingroomPage v-else-if="!running && !isSelfService" :showNameInput="!notYetAccessibleError"/>

    <template v-else-if="showProductPage || showLikeListPage || currentPage">
      <SwPluginSlot name="gs-page-content">
          <ProductPage
            v-if="showProductPage && currentPageResponse"
            :page="currentPageResponse"
            :key="currentPageResponse.product.id"
            class="sw-gs-cms-page sw-gs-dynamic-product-page"
          />
        <SwGsLikeListPage
          v-else-if="showLikeListPage && likeList"
          :like-list="likeList"
        />
        <CmsPage
          v-show="!showProductPage && !showLikeListPage"
          class="sw-gs-cms-page"
          :class="{'sw-gs-cms-product-page': currentPageResponse && currentPageResponse.product}"
          :content="currentPage"
          :key="currentPageKey"
        />
      </SwPluginSlot>
    </template>
  </div>
</template>

<script lang="ts">
  import { computed, onMounted, onUnmounted, ref, watch } from '@vue/composition-api';
  import { provide } from "vue-demi";
  import { useUser, useSharedState } from "@shopware-pwa/composables";
  import { usePresentation } from '../logic/composables/usePresentation';
  import { useAppointment } from '../logic/composables/useAppointment';
  import { useLikeList } from "../logic/composables/useLikeList";
  import { useState } from "../logic/composables/useState";
  import { useGsRoute } from "../logic/composables/useGsRoute";
  import { useMercure } from "../logic/composables/useMercure";
  import { useGsCart } from "../logic/composables/useGsCart";
  import { useMercureObserver } from "../logic/composables/useMercureObserver";
  import { SfLoader } from '@storefront-ui/vue';
  import SwPluginSlot from "sw-plugins/SwPluginSlot.vue"
  import CmsPage from '@/cms/CmsPage.vue';

  const ProductPage = () => import("@/components/views/frontend.detail.page.vue");
  const SwGsLikeListPage = () => import("../components/views/SwGsLikeListPage.vue");
  const SwGsWaitingroomPage = () => import("../components/views/SwGsWaitingroomPage.vue");
  const SwGsLoginPage = () => import("../components/views/SwGsLoginPage.vue");
  const SwGsError = () => import("../components/SwGsError.vue");

  const COMPONENT_NAME = 'presentationClientPage';

  export default {
    name: COMPONENT_NAME,
    components: {
      SwGsLoginPage,
      SfLoader,
      CmsPage,
      ProductPage,
      SwGsLikeListPage,
      SwGsError,
      SwGsWaitingroomPage,
      SwPluginSlot,
    },
    setup() {
      const contextName = COMPONENT_NAME;

      const { sharedRef } = useSharedState();
      const { joinAsClient, joinedAppointment, appointmentId, isSelfService, joinError, getVideoOrAudioAvailableStatus } = useAppointment();
      const { loadPresentation, currentPage, presentation, showProductPage, currentPageResponse,  loadPresentationError, slideLoading } = usePresentation();
      const { initLikeListForClient, likeList, showLikeListPage } = useLikeList();
      const { initCartForClient, } = useGsCart();
      const { initState, stateForAll } = useState();
      const { appointmentId: routeAppointmentId, slide: routeSlideIndex, slideGroup: routeSlideGroupIndex } = useGsRoute();
      const { connect } = useMercure();
      const { subscribeToMercureEvents } = useMercureObserver();
      const { isLoggedIn } = useUser();

      const loading = ref(true);
      const visibilityChangeRegistered = sharedRef<boolean>(`${contextName}-visibilityChangeRegistered`, false);

      provide("cms-page", currentPageResponse);

      provide("gs-product-page-type", computed(() => {
        if (showProductPage.value && currentPageResponse.value) {
          return 'dynamic-page';
        } else if (currentPage.value) {
          return 'cms-page';
        }
        return null;
      }));

      onMounted(async () => {
        await setupPage();

        if (!visibilityChangeRegistered.value) {
          document.addEventListener("visibilitychange", onVisibilityChange);
          visibilityChangeRegistered.value = true;
        }
      });

      async function setupPage() {
        await getVideoOrAudioAvailableStatus(routeAppointmentId.value);

        if (!joinedAppointment.value) {
          appointmentId.value = routeAppointmentId.value;
          await joinAsClient();
        }
        
        if (joinError.value) {
          loading.value = false;
          return;
        }

        // connect to mercure
        connect();
        subscribeToMercureEvents();

        // state needs to be loaded first
        await initState();

        // load presentation and init like list
        loading.value = true;
        await loadPresentation(routeSlideIndex.value, routeSlideGroupIndex.value);
        loading.value = false;

        initLikeListForClient();
        initCartForClient();
      }

      async function onVisibilityChange() {
        await joinAsClient();
        initLikeListForClient();
        initCartForClient();
      }

      onUnmounted(() => {
        visibilityChangeRegistered.value = false;
        document.removeEventListener("visibilitychange", onVisibilityChange);
      });

      // trigger page setup again if first join was not successful and user had to login first
      watch(isLoggedIn, async () => {
        if (!isLoggedIn.value) return;
        loading.value = true;
        await setupPage();
      });

      // trigger page setup again if no more errors are present but also no state
      watch(joinError, async () => {
        if (joinError.value) return;
        if (stateForAll.value) return;
        loading.value = true;
        await setupPage();
      });

      return {
        currentPage,
        currentPageKey: computed(() => currentPage?.value?.sections[0]?._uniqueIdentifier),
        presentation,
        showProductPage,
        currentPageResponse,
        likeList,
        showLikeListPage,
        loading: computed(() => loading.value || slideLoading.value),
        running: computed(() => stateForAll?.value?.running),
        isSelfService,
        isClientAuthenticated: isLoggedIn,
        error: computed(() => joinError.value || loadPresentationError.value),
        notYetAccessibleError: computed(() => joinError.value?.statusCode === 307),
        notFoundError: computed(() => joinError.value?.statusCode === 404),
        notAuthorizedError: computed(() => joinError.value?.statusCode === 403 && !isLoggedIn.value), // in both cases will be sent 403 from api (a: user is not authenticated, b: user IS authenticated but not allowed)
        notAllowed: computed(() => joinError.value?.statusCode === 403 && isLoggedIn.value), // in both cases will be sent 403 from api (a: user is not authenticated, b: user IS authenticated but not allowed)
        joinedAppointment
      };
    },
  };
</script>
